## scriv 0.16.0

=== Makefile ===
# Makefile for scriv
#
# To release:
#   - increment the version in src/scriv/__init__.py
#   - scriv collect
#   - commit changes
#   - make check_release
#   - make release

.PHONY: clean coverage docs help \
	quality requirements test test-all upgrade validate

.DEFAULT_GOAL := help

# For opening files in a browser. Use like: $(BROWSER)relative/path/to/file.html
BROWSER := python -m webbrowser file://$(CURDIR)/

help: ## display this help message
	@echo "Please use \`make <target>' where <target> is one of"
	@awk -F ':.*?## ' '/^[a-zA-Z]/ && NF==2 {printf "\033[36m  %-25s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST) | sort

clean: ## remove generated byte code, coverage reports, and build artifacts
	find . -name '__pycache__' -exec rm -rf {} +
	find . -name '*.pyc' -exec rm -f {} +
	find . -name '*.pyo' -exec rm -f {} +
	find . -name '*~' -exec rm -f {} +
	coverage erase
	rm -fr build/
	rm -fr dist/
	rm -fr *.egg-info
	rm -fr htmlcov/
	rm -fr .*_cache/
	cd docs; make clean

coverage: clean ## generate and view HTML coverage report
	tox -e py37,py310,coverage
	$(BROWSER)htmlcov/index.html

docs: ## generate Sphinx HTML documentation, including API docs
	tox -e docs
	$(BROWSER)docs/_build/html/index.html

upgrade: export CUSTOM_COMPILE_COMMAND=make upgrade
upgrade: ## update the requirements/*.txt files with the latest packages satisfying requirements/*.in
	pip install -qr requirements/pip-tools.txt
	# Make sure to compile files after any other files they include!
	pip-compile --upgrade -o requirements/pip-tools.txt requirements/pip-tools.in
	pip-compile --upgrade -o requirements/base.txt requirements/base.in
	pip-compile --upgrade -o requirements/test.txt requirements/test.in
	pip-compile --upgrade -o requirements/doc.txt requirements/doc.in
	pip-compile --upgrade -o requirements/quality.txt requirements/quality.in
	pip-compile --upgrade -o requirements/tox.txt requirements/tox.in
	pip-compile --upgrade -o requirements/dev.txt requirements/dev.in
	# Splice requirements/base.in into setup.cfg
	sed -n -e '1,/begin_install_requires/p' < setup.cfg > setup.tmp
	sed -n -e '/^[a-zA-Z]/s/^/    /p' < requirements/base.in >> setup.tmp
	sed -n -e '/end_install_requires/,$$p' < setup.cfg >> setup.tmp
	mv setup.tmp setup.cfg

quality: ## check coding style with pycodestyle and pylint
	tox -e quality

requirements: ## install development environment requirements
	pip install -qr requirements/pip-tools.txt
	pip-sync requirements/dev.txt

test: ## run tests in the current virtualenv
	tox -e py38

test-all: ## run tests on every supported Python combination
	tox

validate: clean quality test ## run tests and quality checks

.PHONY: dist pypi testpypi tag gh_release

dist: ## Build the distributions
	python -m build --sdist --wheel

pypi: ## Upload the built distributions to PyPI.
	python -m twine upload --verbose dist/*

testpypi: ## Upload the distrubutions to PyPI's testing server.
	python -m twine upload --verbose --repository testpypi dist/*

tag: ## Make a git tag with the version number
	git tag -a -m "Version $$(python setup.py --version)" $$(python setup.py --version)
	git push --all

gh_release: ## Make a GitHub release
	python -m scriv github-release

.PHONY: release check_release _check_manifest _check_version _check_scriv

release: clean check_release dist pypi tag gh_release ## do all the steps for a release

check_release: _check_manifest _check_tree _check_version _check_scriv ## check that we are ready for a release
	@echo "Release checks passed"

_check_manifest:
	python -m check_manifest

_check_tree:
	@if [[ -n $$(git status --porcelain) ]]; then \
		echo 'There are modified files! Did you forget to check them in?'; \
		exit 1; \
	fi

_check_version:
	@if [[ $$(git tags | grep -q -w $$(python setup.py --version) && echo "x") == "x" ]]; then \
		echo 'A git tag for this version exists! Did you forget to bump the version in src/scriv/__init__.py?'; \
		exit 1; \
	fi

_check_scriv:
	@if (( $$(ls -1 changelog.d | wc -l) != 1 )); then \
		echo 'There are scriv fragments! Did you forget `scriv collect`?'; \
		exit 1; \
	fi

=== debian/changelog ===
scriv (0.16.0-2) unstable; urgency=medium

  * Source-only upload to allow package to migrate to testing.

 -- Edward Betts <edward@4angle.com>  Mon, 15 Aug 2022 11:11:38 +0100

scriv (0.16.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1016755)

 -- Edward Betts <edward@4angle.com>  Mon, 08 Aug 2022 13:11:35 +0100

=== debian/control ===
Source: scriv
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Edward Betts <edward@4angle.com>
Section: python
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               git,
               pandoc,
               python3-all,
               python3-attr,
               python3-click-log,
               python3-click-man,
               python3-freezegun <!nocheck>,
               python3-jinja2,
               python3-pytest <!nocheck>,
               python3-pytest-mock <!nocheck>,
               python3-requests,
               python3-responses <!nocheck>,
               python3-setuptools
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://github.com/nedbat/scriv
Vcs-Browser: https://salsa.debian.org/python-team/packages/scriv
Vcs-Git: https://salsa.debian.org/python-team/packages/scriv.git

Package: scriv
Architecture: all
Depends: git, pandoc, ${misc:Depends}, ${python3:Depends}
Description: Command-line changelog management tool
 Command-line tool for helping developers maintain useful changelogs.
 It manages a directory of changelog fragments. It aggregates them into entries
 in a CHANGELOG file.
 .
 Scriv writes changelog fragments into a directory called "changelog.d".  Start
 by creating this directory.
 .
 To make a new changelog fragment, use the 'scriv create' command.  It will
 make a new file with a filename using the current date and time, your GitHub
 or Git user name, and your branch name.  Changelog fragments should be
 committed along with all the other changes on your branch.
 .
 When it is time to release your project, the 'scriv collect' command
 aggregates all the fragments into a new entry in your changelog file.

=== debian/tests/control ===
Tests: run-tests
Depends: python3-all,
         python3-click-log,
         python3-freezegun,
         python3-pytest,
         python3-pytest-mock,
         python3-responses,
         @

## scriv 0.17.0

=== Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 	cd docs; make clean
 
 coverage: clean ## generate and view HTML coverage report
-	tox -e py37,py310,coverage
+	tox -e py37,py311,coverage
 	$(BROWSER)htmlcov/index.html
 
 docs: ## generate Sphinx HTML documentation, including API docs
@@ -88,7 +88,7 @@
 	git push --all
 
 gh_release: ## Make a GitHub release
-	python -m scriv github-release
+	python -m scriv github-release --all
 
 .PHONY: release check_release _check_manifest _check_version _check_scriv

=== debian/changelog ===
scriv (0.17.0-1) unstable; urgency=medium

  * New upstream release.

 -- Edward Betts <edward@4angle.com>  Sat, 24 Sep 2022 09:05:45 +0100

## scriv 1.0.0

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	find . -name '*.pyo' -exec rm -f {} +
 	find . -name '*~' -exec rm -f {} +
 	coverage erase
+	rm -fr coverage.json
 	rm -fr build/
 	rm -fr dist/
 	rm -fr *.egg-info
@@ -36,7 +37,7 @@
 	tox -e py37,py311,coverage
 	$(BROWSER)htmlcov/index.html
 
-docs: ## generate Sphinx HTML documentation, including API docs
+docs: botedits ## generate Sphinx HTML documentation, including API docs
 	tox -e docs
 	$(BROWSER)docs/_build/html/index.html
 
@@ -57,6 +58,10 @@
 	sed -n -e '/end_install_requires/,$$p' < setup.cfg >> setup.tmp
 	mv setup.tmp setup.cfg
 
+botedits: ## make source edits by tools
+	python -m black --line-length=80 src/scriv tests docs setup.py
+	python -m cogapp -crP docs/*.rst
+
 quality: ## check coding style with pycodestyle and pylint
 	tox -e quality
 
@@ -70,7 +75,7 @@
 test-all: ## run tests on every supported Python combination
 	tox
 
-validate: clean quality test ## run tests and quality checks
+validate: clean botedits quality test ## run tests and quality checks
 
 .PHONY: dist pypi testpypi tag gh_release

=== debian/changelog ===
scriv (1.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Upstream now needs pyyaml for tests, so add Build-Depends.

 -- Edward Betts <edward@4angle.com>  Wed, 07 Dec 2022 06:21:33 +0000

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,8 @@
                python3-pytest-mock <!nocheck>,
                python3-requests,
                python3-responses <!nocheck>,
-               python3-setuptools
+               python3-setuptools,
+               python3-yaml
 Rules-Requires-Root: no
 Standards-Version: 4.6.1
 Homepage: https://github.com/nedbat/scriv

## scriv 1.2.0

=== Makefile ===
--- 
+++ 
@@ -41,22 +41,32 @@
 	tox -e docs
 	$(BROWSER)docs/_build/html/index.html
 
+PIP_COMPILE = pip-compile --upgrade --resolver=backtracking
 upgrade: export CUSTOM_COMPILE_COMMAND=make upgrade
 upgrade: ## update the requirements/*.txt files with the latest packages satisfying requirements/*.in
 	pip install -qr requirements/pip-tools.txt
 	# Make sure to compile files after any other files they include!
-	pip-compile --upgrade -o requirements/pip-tools.txt requirements/pip-tools.in
-	pip-compile --upgrade -o requirements/base.txt requirements/base.in
-	pip-compile --upgrade -o requirements/test.txt requirements/test.in
-	pip-compile --upgrade -o requirements/doc.txt requirements/doc.in
-	pip-compile --upgrade -o requirements/quality.txt requirements/quality.in
-	pip-compile --upgrade -o requirements/tox.txt requirements/tox.in
-	pip-compile --upgrade -o requirements/dev.txt requirements/dev.in
+	$(PIP_COMPILE) -o requirements/pip-tools.txt requirements/pip-tools.in
+	$(PIP_COMPILE) -o requirements/base.txt requirements/base.in
+	$(PIP_COMPILE) -o requirements/test.txt requirements/test.in
+	$(PIP_COMPILE) -o requirements/doc.txt requirements/doc.in
+	$(PIP_COMPILE) -o requirements/quality.txt requirements/quality.in
+	$(PIP_COMPILE) -o requirements/tox.txt requirements/tox.in
+	$(PIP_COMPILE) -o requirements/dev.txt requirements/dev.in
 	# Splice requirements/base.in into setup.cfg
 	sed -n -e '1,/begin_install_requires/p' < setup.cfg > setup.tmp
 	sed -n -e '/^[a-zA-Z]/s/^/    /p' < requirements/base.in >> setup.tmp
 	sed -n -e '/end_install_requires/,$$p' < setup.cfg >> setup.tmp
 	mv setup.tmp setup.cfg
+
+diff_upgrade: ## summarize the last `make upgrade`
+	@# The sort flags sort by the package name first, then by the -/+, and
+	@# sort by version numbers, so we get a summary with lines like this:
+	@#	-bashlex==0.16
+	@#	+bashlex==0.17
+	@#	-build==0.9.0
+	@#	+build==0.10.0
+	@git diff -U0 | grep -v '^@' | grep == | sort -k1.2,1.99 -k1.1,1.1r -u -V
 
 botedits: ## make source edits by tools
 	python -m black --line-length=80 src/scriv tests docs setup.py
@@ -118,7 +128,7 @@
 	fi
 
 _check_scriv:
-	@if (( $$(ls -1 changelog.d | wc -l) != 1 )); then \
+	@if [[ $$(find -E changelog.d -regex '.*\.(md|rst)$$') ]]; then \
 		echo 'There are scriv fragments! Did you forget `scriv collect`?'; \
 		exit 1; \
 	fi

=== debian/changelog ===
scriv (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop the patch to work with old versions of pandoc because  pandoc
    2.17.1.1 has migrated to testing.
  * Update pandoc Depends and Build-Depends with minimum version (>> 2.17).
  * Update copyright year.
  * Update Standards-Version.

 -- Edward Betts <edward@4angle.com>  Fri, 20 Jan 2023 17:43:35 +0000

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/scriv-$1\.tar\.gz/ \
  https://github.com/nedbat/scriv/tags .*/v?(\d\S+)\.tar\.gz

## scriv 1.2.1

=== debian/changelog ===
scriv (1.2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Edward Betts <edward@4angle.com>  Sat, 18 Mar 2023 07:52:25 +0100

## scriv 1.3.1

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #   - make check_release
 #   - make release
 
-.PHONY: clean coverage docs help \
+.PHONY: clean sterile coverage docs help \
 	quality requirements test test-all upgrade validate
 
 .DEFAULT_GOAL := help
@@ -32,6 +32,9 @@
 	rm -fr htmlcov/
 	rm -fr .*_cache/
 	cd docs; make clean
+
+sterile: clean ## remove absolutely all built artifacts
+	rm -fr .tox
 
 coverage: clean ## generate and view HTML coverage report
 	tox -e py37,py311,coverage
@@ -105,9 +108,14 @@
 gh_release: ## Make a GitHub release
 	python -m scriv github-release --all
 
+comment_text:
+	@echo "Use this to comment on issues and pull requests:"
+	@export V=$$(python setup.py --version); \
+		echo "This is now released as part of [scriv $$V](https://pypi.org/project/scriv/$$V)."
+
 .PHONY: release check_release _check_manifest _check_version _check_scriv
 
-release: clean check_release dist pypi tag gh_release ## do all the steps for a release
+release: clean check_release dist pypi tag gh_release comment_text ## do all the steps for a release
 
 check_release: _check_manifest _check_tree _check_version _check_scriv ## check that we are ready for a release
 	@echo "Release checks passed"

=== debian/changelog ===
scriv (1.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Edward Betts <edward@4angle.com>  Tue, 25 Apr 2023 16:03:32 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
                git,
-               pandoc,
+               pandoc (>> 2.17),
                python3-all,
                python3-attr,
                python3-click-log,
@@ -20,14 +20,14 @@
                python3-setuptools,
                python3-yaml
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/nedbat/scriv
 Vcs-Browser: https://salsa.debian.org/python-team/packages/scriv
 Vcs-Git: https://salsa.debian.org/python-team/packages/scriv.git
 
 Package: scriv
 Architecture: all
-Depends: git, pandoc, ${misc:Depends}, ${python3:Depends}
+Depends: git, pandoc (>> 2.17), ${misc:Depends}, ${python3:Depends}
 Description: Command-line changelog management tool
  Command-line tool for helping developers maintain useful changelogs.
  It manages a directory of changelog fragments. It aggregates them into entries

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=scriv
export PYBUILD_TEST_PYTEST=1
export PYBUILD_TEST_ARGS=tests -k "not test_real_get_github_repo"
export PYBUILD_AFTER_BUILD=PYTHONPATH=src python3 setup.py --command-packages=click_man.commands man_pages

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean
	rm -rf src/scriv.egg-info/ man/

## scriv 1.4.0

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 	rm -fr .tox
 
 coverage: clean ## generate and view HTML coverage report
-	tox -e py37,py311,coverage
+	tox -e py37,py312,coverage
 	$(BROWSER)htmlcov/index.html
 
 docs: botedits ## generate Sphinx HTML documentation, including API docs

=== debian/changelog ===
scriv (1.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Edward Betts <edward@4angle.com>  Wed, 18 Oct 2023 11:56:54 +0100

## scriv 1.5.1

=== Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	find . -name '*.pyc' -exec rm -f {} +
 	find . -name '*.pyo' -exec rm -f {} +
 	find . -name '*~' -exec rm -f {} +
-	coverage erase
+	-coverage erase
 	rm -fr coverage.json
 	rm -fr build/
 	rm -fr dist/
@@ -106,19 +106,25 @@
 	git push --all
 
 gh_release: ## Make a GitHub release
-	python -m scriv github-release --all
+	python -m scriv github-release --all --fail-if-warn --check-links
 
 comment_text:
 	@echo "Use this to comment on issues and pull requests:"
 	@export V=$$(python setup.py --version); \
 		echo "This is now released as part of [scriv $$V](https://pypi.org/project/scriv/$$V)."
 
-.PHONY: release check_release _check_manifest _check_version _check_scriv
+.PHONY: release check_release _check_credentials _check_manifest _check_version _check_scriv
 
-release: clean check_release dist pypi tag gh_release comment_text ## do all the steps for a release
+release: _check_credentials clean check_release dist pypi tag gh_release comment_text ## do all the steps for a release
 
-check_release: _check_manifest _check_tree _check_version _check_scriv ## check that we are ready for a release
+check_release: _check_manifest _check_tree _check_version _check_scriv _check_links ## check that we are ready for a release
 	@echo "Release checks passed"
+
+_check_credentials:
+	@if [[ -z "$$TWINE_PASSWORD" ]]; then \
+		echo 'Missing TWINE_PASSWORD: opvars'; \
+		exit 1; \
+	fi
 
 _check_manifest:
 	python -m check_manifest
@@ -140,3 +146,6 @@
 		echo 'There are scriv fragments! Did you forget `scriv collect`?'; \
 		exit 1; \
 	fi
+
+_check_links:
+	python -m scriv github-release --dry-run --fail-if-warn --check-links

=== debian/changelog ===
scriv (1.5.1-2) unstable; urgency=medium

  * Patch tests/test_process.py to fix test failure caused by changes
    in click 8.2.0. (Closes: #1098627)
  * Update copyright year.
  * Update Standards-Version.
  * Move packages required for tests and docs to Build-Depends-Indep.
  * Simplify debian/rules.
  * Simplify debian/watch.

 -- Edward Betts <edward@4angle.com>  Sat, 22 Feb 2025 10:11:25 -0500

scriv (1.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright year.
  * Add Build-Depends for python3-markdown-it, now required by upstream.

 -- Edward Betts <edward@4angle.com>  Sun, 05 May 2024 11:48:51 +0300

=== debian/control ===
Source: scriv
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Edward Betts <edward@4angle.com>,
Section: python
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-all,
 python3-setuptools,
Build-Depends-Indep:
 git,
 pandoc (>> 2.17),
 python3-attr,
 python3-click-log,
 python3-click-man,
 python3-freezegun <!nocheck>,
 python3-jinja2,
 python3-markdown-it <!nocheck>,
 python3-pytest <!nocheck>,
 python3-pytest-mock <!nocheck>,
 python3-requests,
 python3-responses <!nocheck>,
 python3-yaml,
Rules-Requires-Root: no
Standards-Version: 4.7.1
Homepage: https://github.com/nedbat/scriv
Vcs-Browser: https://salsa.debian.org/python-team/packages/scriv
Vcs-Git: https://salsa.debian.org/python-team/packages/scriv.git

Package: scriv
Architecture: all
Depends:
 git,
 pandoc (>> 2.17),
 ${misc:Depends},
 ${python3:Depends},
Description: Command-line changelog management tool
 Command-line tool for helping developers maintain useful changelogs.
 It manages a directory of changelog fragments. It aggregates them into entries
 in a CHANGELOG file.
 .
 Scriv writes changelog fragments into a directory called "changelog.d".  Start
 by creating this directory.
 .
 To make a new changelog fragment, use the 'scriv create' command.  It will
 make a new file with a filename using the current date and time, your GitHub
 or Git user name, and your branch name.  Changelog fragments should be
 committed along with all the other changes on your branch.
 .
 When it is time to release your project, the 'scriv collect' command
 aggregates all the fragments into a new entry in your changelog file.

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,5 @@
 #!/usr/bin/make -f
 
-export PYBUILD_NAME=scriv
-export PYBUILD_TEST_PYTEST=1
 export PYBUILD_TEST_ARGS=tests -k "not test_real_get_github_repo"
 export PYBUILD_AFTER_BUILD=PYTHONPATH=src python3 setup.py --command-packages=click_man.commands man_pages

=== debian/tests/control ===
Tests:
 run-tests,
Depends:
 python3-all,
 python3-click-log,
 python3-freezegun,
 python3-pytest,
 python3-pytest-mock,
 python3-responses,
 python3-yaml,
 @,

## scriv 1.6.2

=== debian/changelog ===
scriv (1.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Switch to autopkgtest-pkg-pybuild.
  * Update Standards-Version.
  * Drop test failure patch, accepted upstream.
  * Use click-man command to generate man page instead of call to setup.py
    because upstream switched from setup.py to pyproject.toml.
  * Patch pyproject.toml to work with older versions of setuptools that are
    missing the latest PEP 639 changes.

 -- Edward Betts <edward@4angle.com>  Mon, 07 Apr 2025 06:37:09 +0100

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,11 @@
  python3-all,
  python3-setuptools,
 Build-Depends-Indep:
+ click-man,
  git,
  pandoc (>> 2.17),
  python3-attr,
  python3-click-log,
- python3-click-man,
  python3-freezegun <!nocheck>,
  python3-jinja2,
  python3-markdown-it <!nocheck>,
@@ -25,10 +25,11 @@
  python3-responses <!nocheck>,
  python3-yaml,
 Rules-Requires-Root: no
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Homepage: https://github.com/nedbat/scriv
 Vcs-Browser: https://salsa.debian.org/python-team/packages/scriv
 Vcs-Git: https://salsa.debian.org/python-team/packages/scriv.git
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: scriv
 Architecture: all

## scriv 1.7.0

=== Makefile ===
--- 
+++ 
@@ -7,13 +7,15 @@
 #   - make check_release
 #   - make release
 
-.PHONY: clean sterile coverage docs help \
-	quality requirements test test-all upgrade validate
-
 .DEFAULT_GOAL := help
 
 # For opening files in a browser. Use like: $(BROWSER)relative/path/to/file.html
 BROWSER := python -m webbrowser file://$(CURDIR)/
+
+# A command to get the current version.  A little slow, but only run when needed.
+VERSION := $$(python -c "import build.util as bu; print(bu.project_wheel_metadata('.')['Version'])")
+
+.PHONY: help clean sterile
 
 help: ## display this help message
 	@echo "Please use \`make <target>' where <target> is one of"
@@ -36,15 +38,17 @@
 sterile: clean ## remove absolutely all built artifacts
 	rm -fr .tox
 
+.PHONY: coverage docs upgrade diff_upgrade
+
 coverage: clean ## generate and view HTML coverage report
-	tox -e py37,py312,coverage
+	tox -e py39,py313,coverage
 	$(BROWSER)htmlcov/index.html
 
 docs: botedits ## generate Sphinx HTML documentation, including API docs
 	tox -e docs
 	$(BROWSER)docs/_build/html/index.html
 
-PIP_COMPILE = pip-compile --upgrade --resolver=backtracking
+PIP_COMPILE = pip-compile --upgrade --resolver=backtracking -c requirements/constraints.txt --no-strip-extras
 upgrade: export CUSTOM_COMPILE_COMMAND=make upgrade
 upgrade: ## update the requirements/*.txt files with the latest packages satisfying requirements/*.in
 	pip install -qr requirements/pip-tools.txt
@@ -56,11 +60,6 @@
 	$(PIP_COMPILE) -o requirements/quality.txt requirements/quality.in
 	$(PIP_COMPILE) -o requirements/tox.txt requirements/tox.in
 	$(PIP_COMPILE) -o requirements/dev.txt requirements/dev.in
-	# Splice requirements/base.in into setup.cfg
-	sed -n -e '1,/begin_install_requires/p' < setup.cfg > setup.tmp
-	sed -n -e '/^[a-zA-Z]/s/^/    /p' < requirements/base.in >> setup.tmp
-	sed -n -e '/end_install_requires/,$$p' < setup.cfg >> setup.tmp
-	mv setup.tmp setup.cfg
 
 diff_upgrade: ## summarize the last `make upgrade`
 	@# The sort flags sort by the package name first, then by the -/+, and
@@ -71,8 +70,11 @@
 	@#	+build==0.10.0
 	@git diff -U0 | grep -v '^@' | grep == | sort -k1.2,1.99 -k1.1,1.1r -u -V
 
+
+.PHONY: botedits quality requirements test test-all validate
+
 botedits: ## make source edits by tools
-	python -m black --line-length=80 src/scriv tests docs setup.py
+	python -m black --line-length=80 src/scriv tests docs
 	python -m cogapp -crP docs/*.rst
 
 quality: ## check coding style with pycodestyle and pylint
@@ -81,39 +83,41 @@
 requirements: ## install development environment requirements
 	pip install -qr requirements/pip-tools.txt
 	pip-sync requirements/dev.txt
+	pip install -e .
 
 test: ## run tests in the current virtualenv
-	tox -e py38
+	tox -e py39
 
 test-all: ## run tests on every supported Python combination
 	tox
 
 validate: clean botedits quality test ## run tests and quality checks
 
-.PHONY: dist pypi testpypi tag gh_release
 
-dist: ## Build the distributions
+.PHONY: dist pypi testpypi tag gh_release comment_text
+
+dist: ## build the distributions
 	python -m build --sdist --wheel
 
-pypi: ## Upload the built distributions to PyPI.
+pypi: ## upload the built distributions to PyPI.
 	python -m twine upload --verbose dist/*
 
-testpypi: ## Upload the distrubutions to PyPI's testing server.
+testpypi: ## upload the distrubutions to PyPI's testing server.
 	python -m twine upload --verbose --repository testpypi dist/*
 
-tag: ## Make a git tag with the version number
-	git tag -a -m "Version $$(python setup.py --version)" $$(python setup.py --version)
+tag: ## make a git tag with the version number
+	git tag -s -m "Version $(VERSION)" $(VERSION)
 	git push --all
 
-gh_release: ## Make a GitHub release
+gh_release: ## make a GitHub release
 	python -m scriv github-release --all --fail-if-warn --check-links
 
 comment_text:
 	@echo "Use this to comment on issues and pull requests:"
-	@export V=$$(python setup.py --version); \
-		echo "This is now released as part of [scriv $$V](https://pypi.org/project/scriv/$$V)."
+	@echo "This is now released as part of [scriv $(VERSION)](https://pypi.org/project/scriv/$(VERSION))."
 
-.PHONY: release check_release _check_credentials _check_manifest _check_version _check_scriv
+
+.PHONY: release check_release _check_credentials _check_manifest _check_tree _check_version _check_scriv _check_links
 
 release: _check_credentials clean check_release dist pypi tag gh_release comment_text ## do all the steps for a release
 
@@ -123,6 +127,10 @@
 _check_credentials:
 	@if [[ -z "$$TWINE_PASSWORD" ]]; then \
 		echo 'Missing TWINE_PASSWORD: opvars'; \
+		exit 1; \
+	fi
+	@if [[ -z "$$GITHUB_TOKEN" ]]; then \
+		echo 'Missing GITHUB_TOKEN: opvars github'; \
 		exit 1; \
 	fi
 
@@ -136,7 +144,7 @@
 	fi
 
 _check_version:
-	@if [[ $$(git tags | grep -q -w $$(python setup.py --version) && echo "x") == "x" ]]; then \
+	@if [[ $$(git tags | grep -q -w $(VERSION) && echo "x") == "x" ]]; then \
 		echo 'A git tag for this version exists! Did you forget to bump the version in src/scriv/__init__.py?'; \
 		exit 1; \
 	fi

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"
	@echo "  dummy      to check syntax errors of document sources"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
scriv (1.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Upstream update copyright year.
  * Needs setuptools (>= 77) because of pyproject.toml PEP 639 changes.
  * Drop PEP 639 patch, required version of setuptools is now in Debian.

 -- Edward Betts <edward@4angle.com>  Sat, 03 May 2025 18:14:57 +0300

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  dh-sequence-python3,
  pybuild-plugin-pyproject,
  python3-all,
- python3-setuptools,
+ python3-setuptools (>= 77),
 Build-Depends-Indep:
  click-man,
  git,

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_TEST_ARGS=tests -k "not test_real_get_github_repo and not test_bad_convert_to_markdown"
export PYBUILD_AFTER_BUILD = PYTHONPATH=src click-man --target=man scriv


%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean
	rm -rf src/scriv.egg-info/ man/

=== debian/watch ===
version=4
https://github.com/nedbat/scriv/tags .*/v?(\d\S+)\.tar\.gz

## scriv 1.8.0

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 #   - increment the version in src/scriv/__init__.py
 #   - scriv collect
 #   - commit changes
+#   - make quality
 #   - make check_release
 #   - make release
 
@@ -41,19 +42,17 @@
 .PHONY: coverage docs upgrade diff_upgrade
 
 coverage: clean ## generate and view HTML coverage report
-	tox -e py39,py313,coverage
+	tox -e py310,py314,coverage
 	$(BROWSER)htmlcov/index.html
 
 docs: botedits ## generate Sphinx HTML documentation, including API docs
 	tox -e docs
 	$(BROWSER)docs/_build/html/index.html
 
-PIP_COMPILE = pip-compile --upgrade --resolver=backtracking -c requirements/constraints.txt --no-strip-extras
-upgrade: export CUSTOM_COMPILE_COMMAND=make upgrade
+PIP_COMPILE = uv pip compile -q --universal -c requirements/constraints.in --upgrade
+upgrade: export UV_CUSTOM_COMPILE_COMMAND=make upgrade
 upgrade: ## update the requirements/*.txt files with the latest packages satisfying requirements/*.in
-	pip install -qr requirements/pip-tools.txt
 	# Make sure to compile files after any other files they include!
-	$(PIP_COMPILE) -o requirements/pip-tools.txt requirements/pip-tools.in
 	$(PIP_COMPILE) -o requirements/base.txt requirements/base.in
 	$(PIP_COMPILE) -o requirements/test.txt requirements/test.in
 	$(PIP_COMPILE) -o requirements/doc.txt requirements/doc.in
@@ -74,19 +73,26 @@
 .PHONY: botedits quality requirements test test-all validate
 
 botedits: ## make source edits by tools
-	python -m black --line-length=80 src/scriv tests docs
+	python -m ruff format src/scriv tests docs
 	python -m cogapp -crP docs/*.rst
 
 quality: ## check coding style with pycodestyle and pylint
 	tox -e quality
 
-requirements: ## install development environment requirements
-	pip install -qr requirements/pip-tools.txt
-	pip-sync requirements/dev.txt
-	pip install -e .
+# For installing development tooling, use uv if it's available, otherwise pip.
+HAS_UV := $(shell command -v uv 2>/dev/null)
+ifdef HAS_UV
+	INSTALL := uv pip sync
+else
+	INSTALL := python -m pip install -r
+endif
+
+install:				## install the developer tools.
+	$(INSTALL) requirements/dev.txt
+	python -m pip install -e .
 
 test: ## run tests in the current virtualenv
-	tox -e py39
+	tox -e py310
 
 test-all: ## run tests on every supported Python combination
 	tox

=== debian/changelog ===
scriv (1.8.0-1) unstable; urgency=medium

  * New upstream release.
  * Patch to fix failing tests.
  * Remove 'Priority: optional', now the default.
  * Update Standards-Version.
  * Update debian/watch to format version 5.

 -- Edward Betts <edward@4angle.com>  Fri, 02 Jan 2026 11:52:08 +0000

scriv (1.7.0-2) unstable; urgency=medium

  * Team upload.
  * d/control: Drop <!nocheck> from python3-markdown-it. Closes: #1116911.
  * d/control: Drop "Rules-Requires-Root: no" (default).
  * Add debian/salsa-ci.yml.

 -- Santiago Vila <sanvila@debian.org>  Wed, 08 Oct 2025 01:40:00 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders:
  Edward Betts <edward@4angle.com>,
 Section: python
-Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
@@ -18,14 +17,13 @@
  python3-click-log,
  python3-freezegun <!nocheck>,
  python3-jinja2,
- python3-markdown-it <!nocheck>,
+ python3-markdown-it,
  python3-pytest <!nocheck>,
  python3-pytest-mock <!nocheck>,
  python3-requests,
  python3-responses <!nocheck>,
  python3-yaml,
-Rules-Requires-Root: no
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/nedbat/scriv
 Vcs-Browser: https://salsa.debian.org/python-team/packages/scriv
 Vcs-Git: https://salsa.debian.org/python-team/packages/scriv.git

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_TEST_ARGS=tests
export PYBUILD_AFTER_BUILD = PYTHONPATH=src click-man --target=man scriv


%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean
	rm -rf src/scriv.egg-info/ man/

=== debian/watch ===
Version: 5

Template: Github
Owner: nedbat
Project: scriv
